<template>
  <div class="room">
    <nuxt-link :to="`/places/${room.id}`" class="room__image">
      <template v-if="!isTouchDevice">
        <img v-for="(image, index) in room.images"
             :key="index"
             v-show="index === hoveredImageIndex"
             :src="image.url"
             :alt="`${room.name} - ${index}`">
      </template>

      <img v-else
           :src="room.images[0].url"
           :alt="room.name">

      <div class="room__image-helpers" v-if="!isTouchDevice && room.images.length > 1">
        <div class="room__image-helper"
             v-for="(image, index) in room.images"
             :key="index"
             v-if="index < 4"
             @mouseover="onHoverImageHelper(index)"
        ></div>
      </div>

      <span v-if="room.tag"
            class="room__tag">
        {{ room.tag }}
      </span>

      <span v-if="room.price"
            class="room__price">
        от {{ room.price | rubCurrency}}
      </span>
    </nuxt-link>

    <nuxt-link :to="`/places/${room.id}`"
               class="room__name">
        {{ room.name }}
    </nuxt-link>

    <div class="room__info">
      <span class="room__info-item"
            v-if="room.area">
        {{ room.area }} м2
      </span>

      <span class="room__info-item"
            v-if="room.capacity">
        до {{ room.capacity }} человек
      </span>

      <span class="room__info-item"
            v-if="room.metro_station">
        Метро {{ room.metro_station.name }}
      </span>
    </div>
  </div>
</template>

<script>
  export default {
    name: 'Room',
    props: {
      room: {
        type: Object,
        required: true
      }
    },
    data: () => ({
      hoveredImageIndex: 0,
      isTouchDevice: false,
    }),
    mounted() {
      this.isTouchDevice = 'ontouchstart' in window;
    },
    methods: {
      onHoverImageHelper(index) {
        this.hoveredImageIndex = index
      }
    }
  }
</script>

<style scoped lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .room {
    width: rem(368);
    overflow: hidden;

    &__image {
      position: relative;

      display: block;
      width: 100%;
      height: rem(210);

      background-color: rgba($black, .16);
      border-radius: rem(4);
      overflow: hidden;

      &:hover {
        .room__image-helpers {
          display: flex;
        }
      }

      img {
        width: 100%;
        height: 100%;

        object-fit: cover;
        object-position: center;
      }
    }

    &__image-helpers {
      display: none;

      position: absolute;
      top: 0;
      left: rem(2);
      right: rem(2);
      bottom: 0;
    }

    &__image-helper {
      position: relative;

      flex: 1 1;
      height: 100%;

      &::after {
        content: '';

        position: absolute;
        left: rem(2);
        right: rem(2);
        bottom: rem(4);

        height: rem(2);

        border-radius: rem(2);
        background: rgba($white, .4);
      }

      &:hover::after {
        background: $white;
      }

    }

    &__tag {
      @include room-card-tag;

      position: absolute;
      top: rem(16);
      left: rem(16);
    }

    &__price {
      position: absolute;

      bottom: rem(16);
      left: rem(16);

      display: flex;
      align-items: center;
      height: rem(32);
      padding: 0 rem(12);

      font-weight: 600;
      font-size: rem(14);
      line-height: rem(20);
      color: $white;

      background: rgba($black, 0.4);
      border-radius: rem(4);
    }

    &__name {
      @include h5;

      &:hover {
        color: $green;
      }

      display: inline-flex;
      margin-top: rem(20);
      margin-bottom: rem(6);
    }

    &__info {
      @include breadcrumbs;
    }
  }
</style>
